10 CLS:CLEAR:SCREEN 0
20 ON ERROR GOTO 920
30 PRINT "      Program GRAPH. Creates an antenna impedance signature over a specified"
40 PRINT "      frequency range, from 3-Meter impedance data. Copyright Peter Dodd G3LDO"
50 PRINT:PRINT:PI = 3.141: B = 50
60 FILES "*.DAT"
70 PRINT " Enter .DAT impedance data file from the above list"
80 INPUT " Remember to add .DAT after the file name";NF$
90 SCREEN 2:CLS
100 DIM AA(9)
110 DIM CC(9)
120 DIM DD(9)
130 DIM EE(9)
140 DIM RR(9)
150 DIM XX(9)
160 DIM ZZ(9)
170 DIM FY(9)
180 DIM EJ(9)
190 DIM P$(9)
200 OPEN "I", #1, NF$
210 INPUT #1, TITLE$
220 INPUT #1, M
230 MM = M
240 FOR Z = 1 TO MM
250 INPUT #1, FY(Z), AA(Z), CC(Z), DD(Z), EE(Z)
260 A = AA(Z)
270 C = CC(Z)
280 D = DD(Z)
290 E = EE(Z)
300 F = (B * B + C * C - A * A) / (2 * B * C)
310 IF F = 0 THEN G = PI / 2: GOTO 330
320 G = ATN(SQR(1 / (F * F) - 1)): IF F < 0 THEN G = PI - G
330 H = (C * C + D * D - E * E) / (2 * C * D)
340 IF H = 0 THEN J = PI / 2: GOTO 360
350 J = ATN(SQR(1 / (H * H) - 1)): IF H < 0 THEN J = PI - J
360 K = (A * A + B * B - C * C) / (2 * A * B)
370 IF K = 0 THEN L = PI / 2: GOTO 390
380 L = ATN(SQR(1 / (K * K) - 1)): IF K < 0 THEN L = PI - L
390 M = (D * D + E * E - C * C) / (2 * D * E)
400 N = ATN(SQR(1 / (M * M) - 1)): IF M < 0 THEN N = PI - N
410 Q = ATN(B / D)
420 T = B / SIN(Q)
430 ZZ = (T * T + E * E - A * A) / (2 * T * E)
440 IF ZZ = 0 THEN P = PI / 2: GOTO 460
450 P = ATN(SQR(1 / (ZZ * ZZ) - 1)): IF ZZ < 0 THEN P = PI - P
460 S = P - Q
470 IF (L + Q) > (PI / 2) THEN S = (2 * PI) - (P + Q)
480 IF H > 0 THEN X1 = D - A * SIN(L) ELSE X1 = D + A * SIN(L)
490 X2 = E * M
500 X3 = E * COS(S)
510 R1 = A * K - B
520 R2 = E * SIN(N)
530 R3 = E * SIN(S)
540 X = (X1 + X2 + X3) / 3
550 R = (R1 + R2 + R3) / 3
560 VP = 164 - (R * .96)
570 HP = ((X + 150) / .625) + 30
580 CIRCLE (HP, VP), 3: IF Z = 1 THEN CIRCLE (HP, VP), 5
590 NEXT Z
600 SCREEN 2
610 PRINT TITLE$; "    Lowest frequency indicated by double circle"
620 PRINT "Freq="; FY(1); FY(2); FY(3); FY(4); FY(5); FY(6); FY(7); FY(8); FY(9)
630 PRINT "150   Dotted ellipses = SWR contours 1.5:1 and 2:1"
640 PRINT : PRINT : PRINT : PRINT : PRINT : PRINT "100"
650 PRINT : PRINT : PRINT : PRINT : PRINT : PRINT "50"
660 PRINT : PRINT : PRINT : PRINT "Res": PRINT : PRINT " 0"
670 PRINT "  -150     -100       -50        0         50       100       150 Xj "
680 FOR V = 30 TO 510 STEP 80
690 LINE (V, 20)-(V, 167), , , &HAAAA
700 NEXT
710 FOR H = 20 TO 164 STEP 48
720 LINE (20, H)-(510, H), , , &HAAAA
730 NEXT
740 FOR RR = 1 TO 100 STEP 2
750 TT = 2 * (PI * RR / 100)
760 VV = (SIN(TT) * 37) + 107
770 HH = (COS(TT) * 68) + 270
780 PSET (HH, VV)
790 NEXT
800 FOR RR = 1 TO 100 STEP 2
810 TT = 2 * (PI * RR / 100)
820 VV = (SIN(TT) * 25) + 110
830 HH = (COS(TT) * 50) + 270
840 PSET (HH, VV)
850 NEXT
860 CLOSE #1
870 INPUT " Goto Main Menu 1.  Repeat this program  2.  " ;AA
880 SCREEN 0
890 IF AA=1 THEN CHAIN "menu"
900 IF AA=2 THEN GOTO 10
910 END
920 PRINT " ERROR IN DATA OR INCORRECT FILE NAME.":RESUME 860
